LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.NUMERIC_STD.ALL;

LIBRARY work;
USE work.YOLO_pkg.ALL;

ENTITY L3_BNROM IS
    PORT (
        clk : IN STD_LOGIC;
        coefs : OUT STD_LOGIC_VECTOR(63 DOWNTO 0); -- Instruction bus
        address : IN unsigned(4 DOWNTO 0));
END L3_BNROM;

ARCHITECTURE RTL OF L3_BNROM IS

    TYPE ROM_mem IS ARRAY (0 TO 31) OF STD_LOGIC_VECTOR(63 DOWNTO 0);

    --kernel2(bias&scale) & kernel1(bias&scale)

    signal ROM_content : ROM_mem :=
    (0=>"1111111101111001"&"0000000111000011"&"0000000111001110"&"0000000110111110",
    1=>"1111111000010000"&"0000001011000000"&"0000000101110100"&"0000001111000011",
    2=>"0000010010100110"&"0000001010011111"&"0000000010101100"&"0000001010011011",
    3=>"0000000001100100"&"0000001100001101"&"0000000101011100"&"0000001100110000",
    4=>"1110110010001111"&"0000001111010111"&"0000110110011101"&"0000001000000101",
    5=>"0000000110010001"&"0000001101001011"&"0000001100110100"&"0000001010001110",
    6=>"0000010101000000"&"0000001010110001"&"1111111110011011"&"0000001100010101",
    7=>"0000010110010110"&"0000001011011010"&"0000000010101111"&"0000001011001100",
    8=>"1111111101000101"&"0000001010111011"&"0000010100101111"&"0000001010110111",
    9=>"0000000011101001"&"0000001100010000"&"0000001110100110"&"0000001110001001",
    10=>"0000001001100110"&"0000000110000101"&"0000101110000011"&"0000001100001010",
    11=>"0000010111100100"&"0000010001001000"&"0000000111100101"&"0000001011010111",
    12=>"0000010110111000"&"0000001011010010"&"0000001111111110"&"0000001110001111",
    13=>"1111111111110100"&"0000001100110001"&"0000110101101000"&"0000011010001101",
    14=>"0000001100111011"&"0000001101010001"&"0000001000011010"&"0000010101111101",
    15=>"0000001111010000"&"0000001100110111"&"0000000100010011"&"0000001110110100",
    16=>"0000000100101101"&"0000001110001011"&"0000001011011001"&"0000001001000000",
    17=>"0000100101010001"&"0000000111010100"&"1111111011111110"&"0000001100011011",
    18=>"0000000011011001"&"0000001001100010"&"0000011110010110"&"0000001010111100",
    19=>"1111111111100111"&"0000001011100011"&"0000000011100110"&"0000001100011101",
    20=>"0000000001001000"&"0000001110101110"&"0000000110111001"&"0000001101010010",
    21=>"0000100010011110"&"0000000110100111"&"0000001000011101"&"0000010000000100",
    22=>"1111111000011111"&"0000001101101011"&"1111110111011011"&"0000000100101010",
    23=>"0000000100101001"&"0000010000010010"&"1111111110100011"&"0000001110000001",
    24=>"1111110111100100"&"0000001010110111"&"0000001101001001"&"0000001101011000",
    25=>"0000000010110110"&"0000001101001101"&"0000000010101011"&"0000001011111101",
    26=>"0000100010100000"&"0000010001001101"&"0000010100101100"&"0000001100001000",
    27=>"0000000011001010"&"0000001100011000"&"0000001011110000"&"0000001010101111",
    28=>"0000010001011011"&"0000001101101001"&"0000011100110100"&"0000010010101011",
    29=>"1111110100100010"&"0000001010000110"&"0000010010000100"&"0000001010110000",
    30=>"1111011100111100"&"0000001101110110"&"0000110110011111"&"0000001010010000",
    31=>"0000001011100011"&"0000001011110010"&"0000001100100000"&"0000001010101011"
);

attribute rom_style : string; 
attribute rom_style of ROM_content : signal is "block";
BEGIN
proc_name : PROCESS (clk)
BEGIN
  IF rising_edge(clk) THEN
    coefs <= ROM_content(to_integer(address));
  END IF;
END PROCESS proc_name;END RTL;